/* generate a random test neural net - 
   do not actually use this as it is
   very hastily hacked together for
   test purposes - final version will
   use code directly from aidoru so
   I wont have to rewrite this all the time
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

#define MAX_GEN_SYNAPSE 6 
#define END_SYNAPSE_FILE 0xAA

float gen_synapse(void);
int vectors_needed(int);

int main(int argc, char **argv)
{
  struct timeval tm;
  int l,n,nc,v;
  FILE *fp;

  /* basic basic basic argument checking */
  if ((argc<4) || ((argc-3) != atoi(argv[2])))
  {
    printf("\nusage: netgen save_file num_layers neurons_in_L1...\n\n");
    return(1);
  }
 
  if ((fp = fopen(argv[1],"w+")) == NULL)
      return(fputs("failed to open input file",stdout));

  gettimeofday(&tm,NULL);
  srandom(~(tm.tv_usec));

  /* write number of layers to the file */
  l = atoi(argv[2]);
  fprintf(fp,"%c",l);

  /* write number of neurons per layer */
  for (n=0; n<l; n++)
    fprintf(fp,"%c",atoi(argv[n+3]));
  
  /* write synapses to file - pad unused with zeros */
  for (l=1; l < atoi(argv[2]); l++)
    for (n=0, nc=0; n<atoi(argv[l+3]); n++, nc=0)
      for (v=0; v<vectors_needed(atoi(argv[l+2])); v++)
      {
         fprintf(fp," %f", (nc++<atoi(argv[l+2])?gen_synapse():0.0f));
         fprintf(fp," %f", (nc++<atoi(argv[l+2])?gen_synapse():0.0f));   
	 fprintf(fp," %f", (nc++<atoi(argv[l+2])?gen_synapse():0.0f));
         fprintf(fp," %f", (nc++<atoi(argv[l+2])?gen_synapse():0.0f)); 
      }  

  /* end file and close */
  fprintf(fp,"%c",END_SYNAPSE_FILE);
  fclose(fp);
  return(0);
}

/* generate a random float synapse */
float gen_synapse(void)
{
  float whole,decimal; 

  /* calc separately for degugging ease */
  whole = (float)(random() % (MAX_GEN_SYNAPSE*2+1) - MAX_GEN_SYNAPSE);
  decimal = (float)((float)(random() % 100000) / 100000.0f);
  return(whole+decimal); 
}

int vectors_needed(int n)
{
   if (n <= 8)
     return((n>=5)?2:1);
   else
     return((n>=13)?4:3);
}    
